// -*- c++ -*-
//  Generated by gtkmmproc from ./../app.gen_h -- DO NOT MODIFY!
#include <gnome--/app.h>
#include <gnome--/private/app_p.h>
#include <gnome--/private/app_p.h>
#include <app-callback.h>

/* app.cc
 *
 * Copyright (C) 2000 The Gtk-- Development Team
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/menubar.h>
#include <gtk--/accelgroup.h>
#include <gtk--/toolbar.h>
#include <gtk--/togglebutton.h>
#include <gnome--/pixmapmenuitem.h>
#include <gnome--/app.h>
#include <gnome--/dock-item.h>
#include <libgnomeui/gnome-stock.h>
#include <libgnomeui/gnome-uidefs.h>
#include <libgnome/gnome-i18n.h>

namespace Gnome {

using namespace SigC;
using namespace Gtk;

App::App(const Gtk::string &appname)
  : Gtk::Window(GTK_WINDOW(gtk_object_new(get_type(),0)))
{
  initialize_class();
  gnome_app_construct(gtkobj(),
		      appname.c_str(),
		      0);
}

App::App(const Gtk::string &appname, const Gtk::string &title)
  : Gtk::Window(GTK_WINDOW(gtk_object_new(get_type(),0)))
{
  initialize_class();
  gnome_app_construct(gtkobj(),
		      appname.c_str(),
		      title.c_str());
}

UI::Array<UI::SubTree>&
App::create_menus(const UI::Array<UI::SubTree> &info)
{
  menus_=info; //Copy for use later by install_menu_hints();.
  gnome_app_create_menus(gtkobj(), menus_.gtkobj());

  return menus_;
}

UI::Array<UI::Info>&
App::insert_menus(const Gtk::string &path, const UI::Array<UI::Info> &menuinfo)
{
  //UI::Info must continue to exist while the menu item exists.
  //because GNOME does not make its own copies of some data.
  //This memory will not be released when remove_menus() is called.

  //Because Array is created implicitly by converting from list/vector/whatever,
  //we can not ask the calling code to do its own memory management.
  //This memory accumulation is unpleasant,
  //but we live in hope that the GNOME menu api will be fixed one day.

  listUIArray_.push_back(menuinfo);
  UI::Array<UI::Info>& refArray = listUIArray_.back();

  gnome_app_insert_menus(gtkobj(), path.c_str(), refArray.gtkobj());

  return refArray;
}


void
App::install_menu_hints()
  {
    gnome_app_install_menu_hints(gtkobj(), menus_.gtkobj());
  }

UI::Array<UI::Info>&
App::create_toolbar(const UI::Array<UI::Info> &info)
  {
    toolbars_=info;
    gnome_app_create_toolbar(gtkobj(), toolbars_.gtkobj());

    return toolbars_;
  }


Gnome::Dialog* App::question(const Gtk::string& message, ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_app_question(gtkobj(), message.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }

Gnome::Dialog* App::question_modal(const Gtk::string& msg, ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_app_question_modal(gtkobj(), msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }

Gnome::Dialog* App::ok_cancel(const Gtk::string& msg, ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_app_ok_cancel(gtkobj(), msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }

Gnome::Dialog* App::ok_cancel_modal(const Gtk::string& msg, ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_app_ok_cancel_modal(gtkobj(), msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }

Gnome::Dialog* App::request_string(const Gtk::string &prompt, StringCallback cb)
  {
    StringHolder* rh=new StringHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_app_request_string(gtkobj(), prompt.c_str(),
                               (GnomeStringCallback)&string_reply_call,rh));
    add_reply(w,rh);
    return w;
  }

Gnome::Dialog* App::request_password(const Gtk::string &prompt, StringCallback cb)
  {
    StringHolder* rh=new StringHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_app_request_password(gtkobj(), prompt.c_str(),
                                 (GnomeStringCallback)&string_reply_call,rh));
    add_reply(w,rh);
    return w;
  }

App::Progress App::progress(const Gtk::string &description, Callback cancel)
  {
    return Progress(*this,  description, cancel);
  }

App::Progress App::progress(const Gtk::string &description, guint32 interval,
                    ProgressCallback percent, Callback cancel)
  {
    return Progress(*this,  description, interval, percent, cancel);
  }



/************************************************************/

namespace {

using namespace Gnome::App_Helpers;
struct ProgressCallbackData
  {
    Progress::Cancel cancel;
    Progress::Update update;
  };

void progress_cancel(gpointer d)
  {
    ProgressCallbackData *data=(ProgressCallbackData*)d;
    data->cancel.call();
  }

gdouble progress_update(gpointer d)
  {
    ProgressCallbackData *data=(ProgressCallbackData*)d;
    return data->update.call();
  }

void progress_destroy(gpointer d)
  {
    ProgressCallbackData *data=(ProgressCallbackData*)d;
    delete data;
  }

}

namespace App_Helpers {

Progress::Progress(Gnome::App& app,
                   const Gtk::string &description,
                   Cancel cancel)
  {
    ProgressCallbackData *data=new ProgressCallbackData();
    data->cancel=cancel;
    app.set_data_full("gnomemm-progress",data, &progress_destroy);
    key_=gnome_app_progress_manual (app.gtkobj(),
                           description.c_str(),
                           &progress_cancel,
                           data);
  }

Progress::Progress(Gnome::App& app,
                   const Gtk::string &description,
                   guint32 interval,
                   Update percent,
                   Cancel cancel)
  {
    ProgressCallbackData *data=new ProgressCallbackData();
    data->cancel=cancel;
    app.set_data_full("gnomemm-progress",data, &progress_destroy);
    key_=gnome_app_progress_timeout (app.gtkobj(),
                            description.c_str(),
                            interval,
                            &progress_update,
                            &progress_cancel, data);
  }

void Progress::set(gdouble percent)
  {
    gnome_app_set_progress(key_,percent);
  }

void Progress::done()
  {
    gnome_app_progress_done(key_);
  }

} /* namespace App_Helpers */


} /* namespace Gnome */
namespace Gtk {
Gnome::App *wrap (GnomeApp *o)
  {
    return static_cast<Gnome::App *> (Gtk::wrap_auto ((GtkObject *) (o)));
  }
}

namespace Gnome {
App_Class App::app_class = {0};

Gtk::Object* App_Class::wrap_new(GtkObject* o)
  {
    Gtk::Object* cpp=manage(new App((GnomeApp*)(o)));
    return cpp;
  }

bool App::isA(Gtk:: Object *checkcast)
  {
    return GNOME_IS_APP(checkcast->gtkobj());
  }

GtkType App::get_type()
  {
    return app_class.get_type();
  }

GtkType App_Class::get_type()
  {
    if (!type)
      {
        CppClassParent::CppObjectType::get_type();
        GtkTypeInfo info =
          {
            "Gnome__App",
            sizeof(BaseObjectType),
            sizeof(BaseClassType),
            (GtkClassInitFunc) class_init_function,
            (GtkObjectInitFunc) object_init_function,
            /* reserved_1 */ NULL,
            /* reserved_2 */ NULL,
            /*base_class_init_func */ (GtkClassInitFunc) NULL
          };
        type=gtk_type_unique(gnome_app_get_type(), &info);
      }
    return type;
  }

const char* const App::signal_names[]={
   0};

void App::initialize_class()
  {

  }

void App_Class::class_init_function(GnomeAppClass *klass)
  {
    CppClassParent::class_init_function((BaseClassParent*)klass);
  }

void App_Class::object_init_function(GnomeApp *)
  {}

}

Gnome::App::App(GnomeApp *castitem)
  :     Gtk::Window((GtkWindow*)(castitem))
  {
    initialize_class();
  }

Gnome::App::~App() { destroy_(); }

void Gnome::App::set_menus(Gtk::MenuBar& menubar)
  {
    gnome_app_set_menus(gtkobj(),menubar.gtkobj());
  }

void Gnome::App::set_toolbar(Gtk::Toolbar& toolbar)
  {
    gnome_app_set_toolbar(gtkobj(),toolbar.gtkobj());
  }

void Gnome::App::set_statusbar(Gtk::Widget& statusbar)
  {
    gnome_app_set_statusbar(gtkobj(),statusbar.gtkobj());
  }

void Gnome::App::set_statusbar_custom(Gtk::Container& container,Gtk::Widget& statusbar)
  {
    gnome_app_set_statusbar_custom(gtkobj(),container.Gtk::Widget::gtkobj(),statusbar.gtkobj());
  }

void Gnome::App::set_contents(Gtk::Widget& contents)
  {
    gnome_app_set_contents(gtkobj(),contents.gtkobj());
  }

void Gnome::App::add_toolbar(Gtk::Toolbar& toolbar,const Gtk::string& name,GnomeDockItemBehavior behavior,GnomeDockPlacement placement,gint band_num,gint band_position,gint offset)
  {
    gnome_app_add_toolbar(gtkobj(),toolbar.gtkobj(),name.c_str(),behavior,placement,band_num,band_position,offset);
  }

void Gnome::App::add_docked(Gtk::Widget& widget,const Gtk::string& name,GnomeDockItemBehavior behavior,GnomeDockPlacement placement,gint band_num,gint band_position,gint offset)
  {
    gnome_app_add_docked(gtkobj(),widget.gtkobj(),name.c_str(),behavior,placement,band_num,band_position,offset);
  }

void Gnome::App::add_dock_item(DockItem& item,GnomeDockPlacement placement,gint band_num,gint band_position,gint offset)
  {
    gnome_app_add_dock_item(gtkobj(),item.gtkobj(),placement,band_num,band_position,offset);
  }

void Gnome::App::enable_layout_config(gboolean enable)
  {
    gnome_app_enable_layout_config(gtkobj(),enable);
  }

Gnome::Dock* Gnome::App::get_dock()
  {
    return Gtk::wrap(gnome_app_get_dock(gtkobj()));
  }

Gnome::DockItem* Gnome::App::get_dock_item_by_name(const Gtk::string& name)
  {
    return Gtk::wrap(gnome_app_get_dock_item_by_name(gtkobj(),name.c_str()));
  }

void Gnome::App::remove_menus(const Gtk::string& path,gint items)
  {
    gnome_app_remove_menus(gtkobj(),path.c_str(),items);
  }

void Gnome::App::remove_menu_range(const Gtk::string& path,gint start,gint items)
  {
    gnome_app_remove_menu_range(gtkobj(),path.c_str(),start,items);
  }

void Gnome::App::flash(const Gtk::string& msg)
  {
    gnome_app_flash(gtkobj(),msg.c_str());
  }

Gnome::Dialog* Gnome::App::message(const Gtk::string& msg)
  {
    return Gtk::wrap((GnomeDialog*)(gnome_app_message(gtkobj(),msg.c_str())));
  }

Gnome::Dialog* Gnome::App::error(const Gtk::string& msg)
  {
    return Gtk::wrap((GnomeDialog*)(gnome_app_error(gtkobj(),msg.c_str())));
  }

Gnome::Dialog* Gnome::App::warning(const Gtk::string& msg)
  {
    return Gtk::wrap((GnomeDialog*)(gnome_app_warning(gtkobj(),msg.c_str())));
  }
