// -*- c++ -*-
//  Generated by gtkmmproc from ./../canvas-item.gen_h -- DO NOT MODIFY!
#include <gnome--/canvas-item.h>
#include <gnome--/private/canvas-item_p.h>
#include <gnome--/private/canvas-item_p.h>

/* canvas-item.cc
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

extern "C"
{
#include <stdarg.h>
}
#include <gnome--/canvas.h>
#include <gnome--/canvas-group.h>

namespace Gnome
{

void
CanvasItem::item_construct(const CanvasGroup &parentx)
{
  gnome_canvas_item_constructv(GNOME_CANVAS_ITEM(gtkobj()),
                              GNOME_CANVAS_GROUP(parentx.gtkobj()),
                              0, NULL);
}

void
CanvasItem::item_construct(const CanvasGroup &parentx,
                                 const gchar* first_arg_name,
                                 va_list ap)
{
  gnome_canvas_item_construct(GNOME_CANVAS_ITEM(gtkobj()),
                              GNOME_CANVAS_GROUP(parentx.gtkobj()),
                              first_arg_name,
                              ap);
}

void
CanvasItem::set(const gchar *first_arg_name, ...)
{
  va_list args;
  va_start(args,first_arg_name);
  gnome_canvas_item_set_valist(gtkobj(), first_arg_name, args);
  va_end(args);
}

//:  Move an item by the specified amount

//: Grab the mouse for the specified item.  Only the events in
//: event_mask will be reported.  If cursor is non-NULL, it will be
//: used during the duration of the grab.  Time is a proper X event
//: time parameter.  Returns the same values as XGrabPointer().
int
CanvasItem::grab (unsigned int event_mask, const Gdk_Cursor &cursor,
			guint32 etime)
{
  return gnome_canvas_item_grab(gtkobj(),event_mask,cursor.gdkobj(),etime);
}

//:  Move an item by the specified amount

//: deprecated
int
CanvasItem::grab (unsigned int event_mask, GdkCursor *cursor,
			guint32 etime)
{
  return gnome_canvas_item_grab(gtkobj(),event_mask,cursor,etime);
}

void
CanvasItem::affine_relative (const Art::AffineTrans &affine)
{
  gnome_canvas_item_affine_relative (gtkobj(), affine.obj());
}

void
CanvasItem::affine_absolute (const Art::AffineTrans &affine)
{
  gnome_canvas_item_affine_absolute (gtkobj(), affine.obj());
}

Art::AffineTrans
CanvasItem::get_i2w_affine() const
{
  double tmp[6] = {0};

  gnome_canvas_item_i2w_affine(const_cast<GnomeCanvasItem*>(gtkobj()), tmp);
  return Art::AffineTrans(tmp);
}

Art::AffineTrans
CanvasItem::get_i2c_affine() const
{
  double tmp[6] = {0};

  gnome_canvas_item_i2c_affine(const_cast<GnomeCanvasItem*>(gtkobj()), tmp);
  return Art::AffineTrans(tmp);
}



} /* namespace Gnome */
namespace Gtk {
Gnome::CanvasItem *wrap (GnomeCanvasItem *o)
  {
    return static_cast<Gnome::CanvasItem *> (Gtk::wrap_auto ((GtkObject *) (o)));
  }
}

namespace Gnome {
CanvasItem_Class CanvasItem::canvas_item_class = {0};

Gtk::Object* CanvasItem_Class::wrap_new(GtkObject* o)
  {
    Gtk::Object* cpp=manage(new CanvasItem((GnomeCanvasItem*)(o)));
    return cpp;
  }

bool CanvasItem::isA(Gtk:: Object *checkcast)
  {
    return GNOME_IS_CANVAS_ITEM(checkcast->gtkobj());
  }

GtkType CanvasItem::get_type()
  {
    return canvas_item_class.get_type();
  }

GtkType CanvasItem_Class::get_type()
  {
    if (!type)
      {
        CppClassParent::CppObjectType::get_type();
        GtkTypeInfo info =
          {
            "Gnome__CanvasItem",
            sizeof(BaseObjectType),
            sizeof(BaseClassType),
            (GtkClassInitFunc) class_init_function,
            (GtkObjectInitFunc) object_init_function,
            /* reserved_1 */ NULL,
            /* reserved_2 */ NULL,
            /*base_class_init_func */ (GtkClassInitFunc) NULL
          };
        type=gtk_type_unique(gnome_canvas_item_get_type(), &info);
      }
    return type;
  }

const char* const CanvasItem::signal_names[]={
   "update",
   "realize",
   "unrealize",
   "map",
   "unmap",
   "coverage",
   "draw",
   "translate",
   "bounds",
   "event",
   0};

void CanvasItem::initialize_class()
  {

     canvas_item_self=this;

  }

void CanvasItem_Class::class_init_function(GnomeCanvasItemClass *klass)
  {
    CppClassParent::class_init_function((BaseClassParent*)klass);
    klass->update=update_callback;
    klass->realize=realize_callback;
    klass->unrealize=unrealize_callback;
    klass->map=map_callback;
    klass->unmap=unmap_callback;
    klass->coverage=coverage_callback;
    klass->draw=draw_callback;
    klass->translate=translate_callback;
    klass->bounds=bounds_callback;
    klass->event=event_callback;
    gtkmm_signal_set_marshal(gtk_signal_lookup("event",CanvasItem::get_type()),&gtkmm_marshal_INT__POINTER);
  }

void CanvasItem_Class::object_init_function(GnomeCanvasItem *)
  {}

}

Gnome::CanvasItem::CanvasItem(GnomeCanvasItem *castitem)
  :     Gtk::Object((GtkObject*)(castitem))
  {
    initialize_class();
  }

Gnome::CanvasItem::~CanvasItem() { destroy_(); }

void Gnome::CanvasItem::move(double dx,double dy)
  {
    gnome_canvas_item_move(gtkobj(),dx,dy);
  }

void Gnome::CanvasItem::raise(int positions)
  {
    gnome_canvas_item_raise(gtkobj(),positions);
  }

void Gnome::CanvasItem::lower(int positions)
  {
    gnome_canvas_item_lower(gtkobj(),positions);
  }

void Gnome::CanvasItem::raise_to_top()
  {
    gnome_canvas_item_raise_to_top(gtkobj());
  }

void Gnome::CanvasItem::lower_to_bottom()
  {
    gnome_canvas_item_lower_to_bottom(gtkobj());
  }

void Gnome::CanvasItem::ungrab(guint32 etime)
  {
    gnome_canvas_item_ungrab(gtkobj(),etime);
  }

void Gnome::CanvasItem::w2i(double& x,double& y)
  {
    gnome_canvas_item_w2i(gtkobj(),&x,&y);
  }

void Gnome::CanvasItem::i2w(double& x,double& y)
  {
    gnome_canvas_item_i2w(gtkobj(),&x,&y);
  }

void Gnome::CanvasItem::grab_focus()
  {
    gnome_canvas_item_grab_focus(gtkobj());
  }

void Gnome::CanvasItem::get_bounds(double& x1,double& y1,double& x2,double& y2)
  {
    gnome_canvas_item_get_bounds(gtkobj(),&x1,&y1,&x2,&y2);
  }

void Gnome::CanvasItem::show()
  {
    gnome_canvas_item_show(gtkobj());
  }

void Gnome::CanvasItem::hide()
  {
    gnome_canvas_item_hide(gtkobj());
  }

void Gnome::CanvasItem_Class::update_callback(GnomeCanvasItem* o_,double* p0,ArtSVP* p1,int p2)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->update_impl(p0,p1,p2);
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->update)
          (base->update)(o_,p0,p1,p2);
      }

  }

void Gnome::CanvasItem::update_impl(double* p0,ArtSVP* p1,int p2)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->update)
      (base->update)(gtkobj(),p0,p1,p2);

  }

void Gnome::CanvasItem_Class::realize_callback(GnomeCanvasItem* o_)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->realize_impl();
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->realize)
          (base->realize)(o_);
      }

  }

void Gnome::CanvasItem::realize_impl()
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->realize)
      (base->realize)(gtkobj());

  }

void Gnome::CanvasItem_Class::unrealize_callback(GnomeCanvasItem* o_)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->unrealize_impl();
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->unrealize)
          (base->unrealize)(o_);
      }

  }

void Gnome::CanvasItem::unrealize_impl()
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->unrealize)
      (base->unrealize)(gtkobj());

  }

void Gnome::CanvasItem_Class::map_callback(GnomeCanvasItem* o_)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->map_impl();
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->map)
          (base->map)(o_);
      }

  }

void Gnome::CanvasItem::map_impl()
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->map)
      (base->map)(gtkobj());

  }

void Gnome::CanvasItem_Class::unmap_callback(GnomeCanvasItem* o_)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->unmap_impl();
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->unmap)
          (base->unmap)(o_);
      }

  }

void Gnome::CanvasItem::unmap_impl()
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->unmap)
      (base->unmap)(gtkobj());

  }

ArtUta* Gnome::CanvasItem_Class::coverage_callback(GnomeCanvasItem* o_)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      return obj->coverage_impl();
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->coverage)
          return (base->coverage)(o_);
        gtkmm_set_ignore();
      }
    return 0;

  }

ArtUta* Gnome::CanvasItem::coverage_impl()
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->coverage)
      return (base->coverage)(gtkobj());
    gtkmm_set_ignore();
    return 0;

  }

void Gnome::CanvasItem_Class::draw_callback(GnomeCanvasItem* o_,GdkDrawable* p0,int p1,int p2,int p3,int p4)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->draw_impl(p0,p1,p2,p3,p4);
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->draw)
          (base->draw)(o_,p0,p1,p2,p3,p4);
      }

  }

void Gnome::CanvasItem::draw_impl(GdkDrawable* p0,int p1,int p2,int p3,int p4)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->draw)
      (base->draw)(gtkobj(),p0,p1,p2,p3,p4);

  }

void Gnome::CanvasItem_Class::translate_callback(GnomeCanvasItem* o_,double p0,double p1)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->translate_impl(p0,p1);
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->translate)
          (base->translate)(o_,p0,p1);
      }

  }

void Gnome::CanvasItem::translate_impl(double p0,double p1)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->translate)
      (base->translate)(gtkobj(),p0,p1);

  }

void Gnome::CanvasItem_Class::bounds_callback(GnomeCanvasItem* o_,double* p0,double* p1,double* p2,double* p3)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->bounds_impl(p0,p1,p2,p3);
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->bounds)
          (base->bounds)(o_,p0,p1,p2,p3);
      }

  }

void Gnome::CanvasItem::bounds_impl(double* p0,double* p1,double* p2,double* p3)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->bounds)
      (base->bounds)(gtkobj(),p0,p1,p2,p3);

  }

gint Gnome::CanvasItem_Class::event_callback(GnomeCanvasItem* o_,GdkEvent* p0)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      return obj->event_impl(p0);
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->event)
          return (base->event)(o_,p0);
        gtkmm_set_ignore();
      }
    return 0;

  }

gint Gnome::CanvasItem::event_impl(GdkEvent* p0)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->event)
      return (base->event)(gtkobj(),p0);
    gtkmm_set_ignore();
    return 0;

  }

Gnome::Canvas* Gnome::CanvasItem::get_canvas() const
  { return Gtk::wrap(gtkobj()->canvas); }

Gnome::CanvasGroup* Gnome::CanvasItem::get_parent() const
  { return Gtk::wrap(GNOME_CANVAS_GROUP(gtkobj()->parent)); }
