// -*- c++ -*-
//  Generated by gtkmmproc from ./../canvas-line.gen_h -- DO NOT MODIFY!
#include <gnome--/canvas-line.h>
#include <gnome--/private/canvas-line_p.h>
#include <gnome--/private/canvas-line_p.h>

/* canvas-line.c
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gnome--/canvas-group.h>

namespace Gnome {

CanvasPoints::CanvasPoints(size_type nbpoints)
  : vector<Art::Point>(nbpoints),
    points_(0), owned_(false)
{}

CanvasPoints::CanvasPoints(GnomeCanvasPoints *castitem) :
  points_(castitem),owned_(false)
{
  int i = 0;

  reserve(points_->num_points);

  for(iterator it = begin(); i < points_->num_points; i+=2, ++it)
    {
      (*it).set_x(points_->coords[i]);
      (*it).set_y(points_->coords[i+1]);
    }
}

CanvasPoints::~CanvasPoints()
{
  if (owned_ && points_) gnome_canvas_points_free(points_);
}

GnomeCanvasPoints*
CanvasPoints::_gtkobj() const
{
  int i = 0;

  if(!points_)
    {
      points_ = gnome_canvas_points_new(size());
      owned_ = true;
    }
  else if(size() != static_cast<unsigned int>(points_->num_points))
    {
      if (owned_) gnome_canvas_points_free(points_);
      points_ = gnome_canvas_points_new(size());
      owned_ = true;
    }

  for(const_iterator it = begin(); it != end(); ++it, i+=2)
    {
      points_->coords[i] = (*it).get_x();
      points_->coords[i+1] = (*it).get_y();
    }
  return points_;
}

CanvasLine::CanvasLine(const CanvasGroup &parentx)
  : CanvasItem(GNOME_CANVAS_ITEM(gtk_object_new(get_type(),0)))
{
  initialize_class();
  item_construct(parentx);
}

CanvasLine::CanvasLine(const CanvasGroup &parentx, const CanvasPoints& points)
  : CanvasItem(GNOME_CANVAS_ITEM(gtk_object_new(get_type(),0)))
{
  initialize_class();
  item_construct(parentx);
  set_points(points);
}

} /* namespace Gnome */
namespace Gtk {
Gnome::CanvasLine *wrap (GnomeCanvasLine *o)
  {
    return static_cast<Gnome::CanvasLine *> (Gtk::wrap_auto ((GtkObject *) (o)));
  }
}

namespace Gnome {
CanvasLine_Class CanvasLine::canvas_line_class = {0};

Gtk::Object* CanvasLine_Class::wrap_new(GtkObject* o)
  {
    Gtk::Object* cpp=manage(new CanvasLine((GnomeCanvasLine*)(o)));
    return cpp;
  }

bool CanvasLine::isA(Gtk:: Object *checkcast)
  {
    return GNOME_IS_CANVAS_LINE(checkcast->gtkobj());
  }

GtkType CanvasLine::get_type()
  {
    return canvas_line_class.get_type();
  }

GtkType CanvasLine_Class::get_type()
  {
    if (!type)
      {
        CppClassParent::CppObjectType::get_type();
        GtkTypeInfo info =
          {
            "Gnome__CanvasLine",
            sizeof(BaseObjectType),
            sizeof(BaseClassType),
            (GtkClassInitFunc) class_init_function,
            (GtkObjectInitFunc) object_init_function,
            /* reserved_1 */ NULL,
            /* reserved_2 */ NULL,
            /*base_class_init_func */ (GtkClassInitFunc) NULL
          };
        type=gtk_type_unique(gnome_canvas_line_get_type(), &info);
      }
    return type;
  }

const char* const CanvasLine::signal_names[]={
   0};

void CanvasLine::initialize_class()
  {

  }

void CanvasLine_Class::class_init_function(GnomeCanvasLineClass *klass)
  {
    CppClassParent::class_init_function((BaseClassParent*)klass);
  }

void CanvasLine_Class::object_init_function(GnomeCanvasLine *)
  {}

}

Gnome::CanvasLine::CanvasLine(GnomeCanvasLine *castitem)
  :     CanvasItem((GnomeCanvasItem*)(castitem))
  {
    initialize_class();
  }

Gnome::CanvasLine::~CanvasLine() { destroy_(); }

void Gnome::CanvasLine::set_points(const CanvasPoints& o)
  {
    set("points",o.gtkobj(),0);
  }

void Gnome::CanvasLine::set_fill_color(const Gtk::string& o)
  {
    set("fill_color",o.c_str(),0);
  }

void Gnome::CanvasLine::set_fill_color(const Gdk_Color& o)
  {
    set("fill_color_gdk",o.gdkobj(),0);
  }

Gdk_Color Gnome::CanvasLine::get_fill_color() const
  {
    GtkArg arg;
    arg.name="fill_color_gdk";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return Gdk_Color(*(GdkColor*)arg.d.pointer_data);
}

void Gnome::CanvasLine::set_fill_stipple(const Gdk_Pixmap& o)
  {
    set("fill_stipple",(GdkWindow*)(o.gdkobj()),0);
  }

Gdk_Pixmap Gnome::CanvasLine::get_fill_stipple() const
  {
    GtkArg arg;
    arg.name="fill_stipple";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return Gdk_Pixmap((GdkPixmap*)arg.d.pointer_data);
}

void Gnome::CanvasLine::set_width_pixels(guint o)
  {
    set("width_pixels",o,0);
  }

void Gnome::CanvasLine::set_width_units(gdouble o)
  {
    set("width_units",o,0);
  }

void Gnome::CanvasLine::set_cap_style(GdkCapStyle o)
  {
    set("cap_style",o,0);
  }

GdkCapStyle Gnome::CanvasLine::get_cap_style() const
  {
    GtkArg arg;
    arg.name="cap_style";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return GdkCapStyle(arg.d.int_data);
}

void Gnome::CanvasLine::set_join_style(GdkJoinStyle o)
  {
    set("join_style",o,0);
  }

GdkJoinStyle Gnome::CanvasLine::get_join_style() const
  {
    GtkArg arg;
    arg.name="join_style";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return GdkJoinStyle(arg.d.int_data);
}

void Gnome::CanvasLine::set_line_style(GdkLineStyle o)
  {
    set("line_style",o,0);
  }

GdkLineStyle Gnome::CanvasLine::get_line_style() const
  {
    GtkArg arg;
    arg.name="line_style";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return GdkLineStyle(arg.d.int_data);
}

void Gnome::CanvasLine::set_first_arrowhead(bool o)
  {
    set("first_arrowhead",((o)?true:false),0);
  }

bool Gnome::CanvasLine::get_first_arrowhead() const
  {
    GtkArg arg;
    arg.name="first_arrowhead";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return (int)arg.d.int_data;
}

void Gnome::CanvasLine::set_last_arrowhead(bool o)
  {
    set("last_arrowhead",((o)?true:false),0);
  }

bool Gnome::CanvasLine::get_last_arrowhead() const
  {
    GtkArg arg;
    arg.name="last_arrowhead";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return (int)arg.d.int_data;
}

void Gnome::CanvasLine::set_smooth(bool o)
  {
    set("smooth",((o)?true:false),0);
  }

bool Gnome::CanvasLine::get_smooth() const
  {
    GtkArg arg;
    arg.name="smooth";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return (int)arg.d.int_data;
}

void Gnome::CanvasLine::set_spline_step(guint o)
  {
    set("spline_step",o,0);
  }

guint Gnome::CanvasLine::get_spline_step() const
  {
    GtkArg arg;
    arg.name="spline_step";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return arg.d.uint_data;
}

void Gnome::CanvasLine::set_arrow_shape_a(gdouble o)
  {
    set("arrow_shape_a",o,0);
  }

gdouble Gnome::CanvasLine::get_arrow_shape_a() const
  {
    GtkArg arg;
    arg.name="arrow_shape_a";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return arg.d.double_data;
}

void Gnome::CanvasLine::set_arrow_shape_b(gdouble o)
  {
    set("arrow_shape_b",o,0);
  }

gdouble Gnome::CanvasLine::get_arrow_shape_b() const
  {
    GtkArg arg;
    arg.name="arrow_shape_b";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return arg.d.double_data;
}

void Gnome::CanvasLine::set_arrow_shape_c(gdouble o)
  {
    set("arrow_shape_c",o,0);
  }

gdouble Gnome::CanvasLine::get_arrow_shape_c() const
  {
    GtkArg arg;
    arg.name="arrow_shape_c";
    gtk_object_getv(const_cast<GtkObject*>(this->Gtk::Object::gtkobj()),1,&arg);
    return arg.d.double_data;
}
