// -*- c++ -*-
//  Generated by gtkmmproc from ./../dialog.gen_h -- DO NOT MODIFY!
#include <gnome--/dialog.h>
#include <gnome--/private/dialog_p.h>
#include <gnome--/private/dialog_p.h>
#include <gnome--/app-callback.h>
/* dialog.cc
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <gtk--/editable.h>
#include <gtk--/box.h>
#include <gtk--/button.h>

namespace Gnome
{
  using namespace SigC;
  using namespace Gtk;

Dialog::Dialog()
  : Gtk::Window(GTK_WINDOW(gtk_object_new(get_type(),0)))
{
  initialize_class();

  //Prevent automatic gtkobj destruction upon dialog close.
  //It's not suitable for C++.
  close_hides();
}

//: This constructor is really quite useless.
Dialog::Dialog(const Gtk::string &title,
               const Gtk::SArray &buttons)
  : Gtk::Window(GTK_WINDOW(gtk_object_new(get_type(),0)))
{
  initialize_class();

  const gchar **buttons_ = (const gchar**)buttons;
  gnome_dialog_constructv(gtkobj(), title.c_str(), buttons_);

  //Prevent automatic gtkobj destruction upon dialog close.
  //It's not suitable for C++.
  close_hides();
}

Gtk::Button* Dialog::get_button(gint number) const
  {
    return Gtk::wrap((GtkButton*)(g_list_nth (gtkobj()->buttons, number)->data));
  }

void Dialog::connect(gint number, const Callback& s)
  {
    Gtk::Button *b=get_button(number);
    if (b)
       b->clicked.connect(s);
  }

/********************************************************************/

namespace Dialogs {


Dialog* ok(const Gtk::string &msg)
  { return wrap((GnomeDialog*)gnome_ok_dialog(msg.c_str())); }
Dialog* ok(Gtk::Window& parent,const Gtk::string &msg)
  { return wrap((GnomeDialog*)gnome_ok_dialog_parented(msg.c_str(),parent.gtkobj())); }

Dialog* warning(const Gtk::string &msg)
  { return wrap((GnomeDialog*)gnome_warning_dialog(msg.c_str())); }
Dialog* warning(Gtk::Window& parent,const Gtk::string &msg)
  { return wrap((GnomeDialog*)gnome_warning_dialog_parented(msg.c_str(),parent.gtkobj())); }

Dialog* error(const Gtk::string &msg)
  { return wrap((GnomeDialog*)gnome_error_dialog(msg.c_str())); }
Dialog* error(Gtk::Window& parent,const Gtk::string &msg)
  { return wrap((GnomeDialog*)gnome_error_dialog_parented(msg.c_str(),parent.gtkobj())); }


Dialog* question(const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_question_dialog(msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }
Dialog* question(Gtk::Window& parent,const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_question_dialog_parented(msg.c_str(),
        &reply_call,rh,parent.gtkobj()));
    add_reply(w,rh);
    return w;
  }

Dialog* question_modal(const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_question_dialog_modal(msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }
Dialog* question_modal(Gtk::Window& parent,const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_question_dialog_modal_parented(msg.c_str(),
        &reply_call,rh,parent.gtkobj()));
    add_reply(w,rh);
    return w;
  }


Dialog* ok_cancel(const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_ok_cancel_dialog(msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }
Dialog* ok_cancel(Gtk::Window& parent,const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_ok_cancel_dialog_parented(msg.c_str(),
        &reply_call,rh,parent.gtkobj()));
    add_reply(w,rh);
    return w;
  }

Dialog* ok_cancel_modal(const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_ok_cancel_dialog_modal(msg.c_str(),&reply_call,rh));
    add_reply(w,rh);
    return w;
  }
Dialog* ok_cancel_modal(Gtk::Window& parent,const Gtk::string &msg,ReplyCallback cb)
  {
    ReplyHolder* rh=new ReplyHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_ok_cancel_dialog_modal_parented(msg.c_str(),
        &reply_call,rh,parent.gtkobj()));
    add_reply(w,rh);
    return w;
  }

Dialog* request(bool hidden,
                const Gtk::string& prompt,
                const Gtk::string& initial,
                guint16 max,
                StringCallback cb)
  {
    StringHolder* rh=new StringHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_request_dialog(hidden,prompt.c_str(),initial.c_str(),max,
                           (GnomeStringCallback)&string_reply_call,rh,0));
    add_reply(w,rh);
    return w;
  }
Dialog* request(Gtk::Window& parent,
                bool hidden,
                const Gtk::string& prompt,
                const Gtk::string& initial,
                guint16 max,
                StringCallback cb)
  {
    StringHolder* rh=new StringHolder(cb);
    Gnome::Dialog* w=wrap((GnomeDialog*)
      gnome_request_dialog(hidden,prompt.c_str(),initial.c_str(),max,
                           (GnomeStringCallback)&string_reply_call,rh,parent.gtkobj()));
    add_reply(w,rh);
    return w;
  }

} /* namespace Dialogs */
} /* namespace Gnome */
namespace Gtk {
Gnome::Dialog *wrap (GnomeDialog *o)
  {
    return static_cast<Gnome::Dialog *> (Gtk::wrap_auto ((GtkObject *) (o)));
  }
}

namespace Gnome {
Dialog_Class Dialog::dialog_class = {0};

Gtk::Object* Dialog_Class::wrap_new(GtkObject* o)
  {
    Gtk::Object* cpp=manage(new Dialog((GnomeDialog*)(o)));
    return cpp;
  }

bool Dialog::isA(Gtk:: Object *checkcast)
  {
    return GNOME_IS_DIALOG(checkcast->gtkobj());
  }

GtkType Dialog::get_type()
  {
    return dialog_class.get_type();
  }

GtkType Dialog_Class::get_type()
  {
    if (!type)
      {
        CppClassParent::CppObjectType::get_type();
        GtkTypeInfo info =
          {
            "Gnome__Dialog",
            sizeof(BaseObjectType),
            sizeof(BaseClassType),
            (GtkClassInitFunc) class_init_function,
            (GtkObjectInitFunc) object_init_function,
            /* reserved_1 */ NULL,
            /* reserved_2 */ NULL,
            /*base_class_init_func */ (GtkClassInitFunc) NULL
          };
        type=gtk_type_unique(gnome_dialog_get_type(), &info);
      }
    return type;
  }

const char* const Dialog::signal_names[]={
   "clicked",
   "close",
   0};

void Dialog::initialize_class()
  {

     dialog_self=this;

  }

void Dialog_Class::class_init_function(GnomeDialogClass *klass)
  {
    CppClassParent::class_init_function((BaseClassParent*)klass);
    klass->clicked=clicked_callback;
    klass->close=close_callback;
    gtkmm_signal_set_marshal(gtk_signal_lookup("close",Dialog::get_type()),&gtkmm_marshal_BOOL__NONE);
  }

void Dialog_Class::object_init_function(GnomeDialog *)
  {}

}

Gnome::Dialog::Dialog(GnomeDialog *castitem)
  :     Gtk::Window((GtkWindow*)(castitem))
  {
    initialize_class();
  }

Gnome::Dialog::~Dialog() { destroy_(); }

void Gnome::Dialog::set_parent(Gtk::Window& parent)
  {
    gnome_dialog_set_parent(gtkobj(),parent.gtkobj());
  }

gint Gnome::Dialog::run()
  {
    return gnome_dialog_run(gtkobj());
  }

gint Gnome::Dialog::run_and_close()
  {
    return gnome_dialog_run_and_close(gtkobj());
  }

void Gnome::Dialog::set_default(gint button)
  {
    gnome_dialog_set_default(gtkobj(),button);
  }

void Gnome::Dialog::set_sensitive(gint button,gboolean setting)
  {
    gnome_dialog_set_sensitive(gtkobj(),button,setting);
  }

void Gnome::Dialog::set_accelerator(gint button,const guchar accelerator_key,guint8 accelerator_mods)
  {
    gnome_dialog_set_accelerator(gtkobj(),button,accelerator_key,accelerator_mods);
  }

void Gnome::Dialog::cause_close()
  {
    gnome_dialog_close(gtkobj());
  }

void Gnome::Dialog::close_hides(gboolean just_hide)
  {
    gnome_dialog_close_hides(gtkobj(),just_hide);
  }

void Gnome::Dialog::set_close(gboolean click_closes)
  {
    gnome_dialog_set_close(gtkobj(),click_closes);
  }

void Gnome::Dialog::append_button(const Gtk::string& name)
  {
    gnome_dialog_append_button(gtkobj(),name.c_str());
  }

void Gnome::Dialog::append_button(const Gtk::string& name,const Gtk::string& pixmap)
  {
    gnome_dialog_append_button_with_pixmap(gtkobj(),name.c_str(),pixmap.c_str());
  }

void Gnome::Dialog::editable_enters(Gtk::Editable& e)
  {
    gnome_dialog_editable_enters(gtkobj(),e.gtkobj());
  }

void Gnome::Dialog_Class::clicked_callback(GnomeDialog* o_,gint p0)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      obj->clicked_impl(p0);
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->clicked)
          (base->clicked)(o_,p0);
      }

  }

void Gnome::Dialog::clicked_impl(gint p0)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->clicked)
      (base->clicked)(gtkobj(),p0);

  }

gboolean Gnome::Dialog_Class::close_callback(GnomeDialog* o_)
  {
    CppObjectType *obj=
      static_cast<CppObjectType *>(static_cast<Gtk::Object *>(
        gtk_object_get_data_by_id((GtkObject*)o_,Gtk::quark_)));

    if (obj)
      return obj->close_impl();
    else
      {
        BaseClassType* base=
          static_cast<BaseClassType*>(
            gtk_type_parent_class(((GtkObject*)o_)->klass->type));
        if (base->close)
          return (base->close)(o_);
        gtkmm_set_ignore();
      }
    return 0;

  }

gboolean Gnome::Dialog::close_impl()
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        gtk_type_parent_class(gtkobject->klass->type));
    if (base->close)
      return (base->close)(gtkobj());
    gtkmm_set_ignore();
    return 0;

  }

Gtk::VBox* Gnome::Dialog::get_vbox() const
  { return Gtk::wrap((GtkVBox*)(gtkobj()->vbox)); }
