// -*- c++ -*-
//  Generated by gtkmmproc from ./../pixmap.gen_h -- DO NOT MODIFY!
#include <gnome--/pixmap.h>
#include <gnome--/private/pixmap_p.h>
#include <gnome--/private/pixmap_p.h>

#include <sys/stat.h>
#include <unistd.h>

/* pixmap.cc
 *
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

namespace Gnome {

Pixmap::Pixmap(const Gtk::string &filename)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(filename);
}

Pixmap::Pixmap(const Gtk::string &filename, int widthx, int heightx)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(filename, widthx, heightx);
}

Pixmap::Pixmap(char ** xpm_data)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(xpm_data);
}

Pixmap::Pixmap(char ** xpm_data, int widthx, int heightx)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(xpm_data, widthx, heightx);
}

Pixmap::Pixmap(const Gdk_Imlib::Image &im)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(im);
}

Pixmap::Pixmap(const Gdk_Imlib::Image &im, int widthx, int heightx)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(im, widthx, heightx);
}

Pixmap::Pixmap(unsigned char * rgb_data, unsigned char * alpha,
			   int rgb_width, int rgb_height)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(rgb_data, alpha, rgb_width, rgb_height);
}

Pixmap::Pixmap(unsigned char * rgb_data, unsigned char * alpha,
			   int rgb_width, int rgb_height,
			   const Gdk_Imlib::Color &shape_color)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(rgb_data, alpha, rgb_width, rgb_height, shape_color);
}

Pixmap::Pixmap(unsigned char * rgb_data, unsigned char * alpha,
			   int rgb_width, int rgb_height,
			   int widthx, int heightx)
  : Gtk::Widget(GTK_WIDGET(gtk_object_new(get_type(),0)))
{
  initialize_class();
  load(rgb_data, alpha, rgb_width, rgb_height, widthx, heightx);
}

void
Pixmap::load(unsigned char *data,
		   unsigned char *alpha,
		   int rgb_width,
		   int rgb_height,
		   const Gdk_Imlib::Color &shape_color)
{
  gnome_pixmap_load_rgb_d_shaped(gtkobj(), data, alpha,
				 rgb_width, rgb_height,
				 const_cast<GdkImlibColor*>(shape_color.gdkobj()));
}


void
Pixmap::load(const Gdk_Imlib::Image &im, int width, int height)
{
  if (width && height)
    gnome_pixmap_load_imlib_at_size(gtkobj(),
				    const_cast<GdkImlibImage*>(im.gdkobj()),
				    width, height);
  else
    gnome_pixmap_load_imlib(gtkobj(),
			    const_cast<GdkImlibImage*>(im.gdkobj()));
}


void
Pixmap::load(const Gtk::string &filename, int width, int height)
{
  struct stat dummyBuf;

  if(stat(filename.c_str(), &dummyBuf) == -1) // file isn't there
    {
      load(Gdk_Pixmap::defaultPixmap);
      Gdk_Pixmap::warn_about_xpm_file_problem(filename);
    }
  else
    if (width && height)
      gnome_pixmap_load_file_at_size(gtkobj(), filename.c_str(),
				     width, height);
    else
      gnome_pixmap_load_file(gtkobj(), filename.c_str());
}

//static:
Gtk::string
Pixmap::find_file(const Gtk::string& filename)
{
  Gtk::string strResult;

  gchar* pchFilepath = gnome_pixmap_file(filename.c_str());
  if(pchFilepath)
  {
    strResult = pchFilepath;
    g_free(pchFilepath);
  }

  return strResult;
}

} /* namespace Gnome */
namespace Gtk {
Gnome::Pixmap *wrap (GnomePixmap *o)
  {
    return static_cast<Gnome::Pixmap *> (Gtk::wrap_auto ((GtkObject *) (o)));
  }
}

namespace Gnome {
Pixmap_Class Pixmap::pixmap_class = {0};

Gtk::Object* Pixmap_Class::wrap_new(GtkObject* o)
  {
    Gtk::Object* cpp=manage(new Pixmap((GnomePixmap*)(o)));
    return cpp;
  }

bool Pixmap::isA(Gtk:: Object *checkcast)
  {
    return GNOME_IS_PIXMAP(checkcast->gtkobj());
  }

GtkType Pixmap::get_type()
  {
    return pixmap_class.get_type();
  }

GtkType Pixmap_Class::get_type()
  {
    if (!type)
      {
        CppClassParent::CppObjectType::get_type();
        GtkTypeInfo info =
          {
            "Gnome__Pixmap",
            sizeof(BaseObjectType),
            sizeof(BaseClassType),
            (GtkClassInitFunc) class_init_function,
            (GtkObjectInitFunc) object_init_function,
            /* reserved_1 */ NULL,
            /* reserved_2 */ NULL,
            /*base_class_init_func */ (GtkClassInitFunc) NULL
          };
        type=gtk_type_unique(gnome_pixmap_get_type(), &info);
      }
    return type;
  }

const char* const Pixmap::signal_names[]={
   0};

void Pixmap::initialize_class()
  {

  }

void Pixmap_Class::class_init_function(GnomePixmapClass *klass)
  {
    CppClassParent::class_init_function((BaseClassParent*)klass);
  }

void Pixmap_Class::object_init_function(GnomePixmap *)
  {}

}

Gnome::Pixmap::Pixmap()
  :     Gtk::Widget((GtkWidget*)(gtk_object_new(get_type(),0)))
  {
    initialize_class();
  }

Gnome::Pixmap::Pixmap(GnomePixmap *castitem)
  :     Gtk::Widget((GtkWidget*)(castitem))
  {
    initialize_class();
  }

Gnome::Pixmap::~Pixmap() { destroy_(); }

void Gnome::Pixmap::load(char** xpm_data)
  {
    gnome_pixmap_load_xpm_d(gtkobj(),xpm_data);
  }

void Gnome::Pixmap::load(char** xpm_data,int width,int height)
  {
    gnome_pixmap_load_xpm_d_at_size(gtkobj(),xpm_data,width,height);
  }

void Gnome::Pixmap::load(unsigned char* rgb_data,unsigned char* alpha,int rgb_width,int rgb_height)
  {
    gnome_pixmap_load_rgb_d(gtkobj(),rgb_data,alpha,rgb_width,rgb_height);
  }

void Gnome::Pixmap::load(unsigned char* data,unsigned char* alpha,int rgb_width,int rgb_height,int width,int height)
  {
    gnome_pixmap_load_rgb_d_at_size(gtkobj(),data,alpha,rgb_width,rgb_height,width,height);
  }
